/****************************************************************************************
**  LINX header for serial listener.
**
**  For more information see:           www.labviewmakerhub.com/linx
**  For support visit the forums at:    www.labviewmakerhub.com/forums/linx
**
**  Written By Sam Kristoff
**
** BSD2 License.
****************************************************************************************/

#ifndef LINX_SERIAL_LISTENER_H
#define LINX_SERIAL_LISTENER_H

/****************************************************************************************
**  Defines
****************************************************************************************/

/****************************************************************************************
**  Includes
****************************************************************************************/
#include "esp32-hal-gpio.h"
#include "utility/LinxListener.h"
#include "utility/LinxDevice.h"


/****************************************************************************************
**  Type Defs
****************************************************************************************/

/****************************************************************************************
**  Classes
****************************************************************************************/
class LinxSerialListener : public LinxListener
{
  public:
    /****************************************************************************************
    **  Variables
    ****************************************************************************************/
    LinxListenerState State;
    //unsigned char LinxSerialListenerChan;

    /****************************************************************************************
    **  Constructors
    ****************************************************************************************/
    LinxSerialListener();		//Default Constructor

    /****************************************************************************************
    **  Functions
    ****************************************************************************************/
    virtual int Start(LinxDevice* linxDev, unsigned char uartChan);
    virtual int Connected();
    virtual int Close();
    virtual int Exit();

    virtual int CheckForCommands();

  private:
    /****************************************************************************************
    **  Variables
    ****************************************************************************************/

    /****************************************************************************************
    **  Functions
    ****************************************************************************************/

};

extern LinxSerialListener LinxSerialConnection;

#endif //LINX_SERIAL_LISTENER_H
